package pvc

import (
	"github.com/ankitrgadiya/operatorlib/pkg/interfaces"
	"github.com/ankitrgadiya/operatorlib/pkg/meta"

	corev1 "k8s.io/api/core/v1"
	"k8s.io/apimachinery/pkg/runtime"
)

type GenPVCFunc func(Conf) (*corev1.PersistentVolumeClaim, error)

type GenResourcesFunc func() (corev1.ResourceRequirements, error)
type GenAccessModesFunc func() ([]corev1.PersistentVolumeAccessMode, error)

type Conf struct {
	Owner          interfaces.Object
	Namespace      string
	Name           string
	OwnerReference bool
	Reconcile      interfaces.Reconcile
	previousObject runtime.Object
	Obj            interfaces.Object
	GenFinalizers  meta.GenFinalizers
	GenLabels      meta.GenLabels
	GenAnnotations meta.GenAnnotations
	GenPVCFunc
	StorageClassName *string
	GenResourcesFunc
	GenAccessModesFunc
}

type Mutate interface {
	meta.Mutate

	GenResources() (corev1.ResourceRequirements, error)
	GenAccessModes() ([]corev1.PersistentVolumeAccessMode, error)
}
